// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::ShortcutTheme;
use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlShortcutThemeEditor")]
    pub struct ShortcutThemeEditor(Object<ffi::DzlShortcutThemeEditor, ffi::DzlShortcutThemeEditorClass>) @extends gtk::Bin, gtk::Container, gtk::Widget, @implements gtk::Buildable;

    match fn {
        type_ => || ffi::dzl_shortcut_theme_editor_get_type(),
    }
}

impl ShortcutThemeEditor {
    pub const NONE: Option<&'static ShortcutThemeEditor> = None;

    #[doc(alias = "dzl_shortcut_theme_editor_new")]
    pub fn new() -> ShortcutThemeEditor {
        assert_initialized_main_thread!();
        unsafe { gtk::Widget::from_glib_none(ffi::dzl_shortcut_theme_editor_new()).unsafe_cast() }
    }
}

impl Default for ShortcutThemeEditor {
    fn default() -> Self {
        Self::new()
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::ShortcutThemeEditor>> Sealed for T {}
}

pub trait ShortcutThemeEditorExt: IsA<ShortcutThemeEditor> + sealed::Sealed + 'static {
    #[doc(alias = "dzl_shortcut_theme_editor_get_theme")]
    #[doc(alias = "get_theme")]
    fn theme(&self) -> Option<ShortcutTheme> {
        unsafe {
            from_glib_none(ffi::dzl_shortcut_theme_editor_get_theme(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_shortcut_theme_editor_set_theme")]
    fn set_theme(&self, theme: &impl IsA<ShortcutTheme>) {
        unsafe {
            ffi::dzl_shortcut_theme_editor_set_theme(
                self.as_ref().to_glib_none().0,
                theme.as_ref().to_glib_none().0,
            );
        }
    }

    #[doc(alias = "changed")]
    fn connect_changed<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn changed_trampoline<
            P: IsA<ShortcutThemeEditor>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlShortcutThemeEditor,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(ShortcutThemeEditor::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"changed\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    changed_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "theme")]
    fn connect_theme_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_theme_trampoline<
            P: IsA<ShortcutThemeEditor>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlShortcutThemeEditor,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(ShortcutThemeEditor::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::theme\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_theme_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl<O: IsA<ShortcutThemeEditor>> ShortcutThemeEditorExt for O {}

impl fmt::Display for ShortcutThemeEditor {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("ShortcutThemeEditor")
    }
}
